Leetcode 62. Unique Paths

A robot is located at the top-left corner of a m x n grid (marked ‘Start’ in the diagram below).

The robot can only move either down or right at any point in time. The robot is trying to reach the bottom-right corner of the grid (marked ‘Finish’ in the diagram below).
这里写图片描述
How many possible unique paths are there?

Above is a 3 x 7 grid. How many possible unique paths are there?

Note: m and n will be at most 100.

s思路:
1. dp做。因为到终点终点只有两种方式:上边和左边,所以到终点的数量=上边点的数量+左边点的数量。这个过程是recursive的。需要注意的是:有可能某个点的数量需要多次计算,为了减少运算,可以用memorization,这就是所谓的bottom-up DP.
2. 当然,好理解的DP还是top-down,即:计算每个点的次数,先依次计算和起点同一行、同一列的所有点的次数,然后后面的位置都可以由:dp[i][j]=dp[i-1][j]+dp[i][j-1]得到。
3. dp空间上可以优化。因为每个数之和左边和上边数有关系,即:每个数只被使用一次,这种情况我们可以把2d的dp修改成1d的dp。见方法2。

//方法1: 2d top-down DP
class Solution {
public:
    int uniquePaths(int m, int n) {
        //
        int dp[m][n]={0};
        for(int i=0;i<n;i++)
            dp[0][i]=1;
        for(int i=1;i<m;i++)
            dp[i][0]=1;
        for(int i=1;i<m;i++){
            for(int j=1;j<n;j++)
                dp[i][j]=dp[i-1][j]+dp[i][j-1];
        }
        return dp[m-1][n-1];
    }
};

//方法2: 1d top-down DP
class Solution {
public:
    int uniquePaths(int m, int n) {
        //
        int dp[n+1]={0};
        dp[1]=1;
        for(int i=0;i<m;i++){
            for(int j=2;j<=n;j++)
                dp[j]=dp[j]+dp[j-1];
        }
        return dp[n];
    }
};
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值